#include <omp.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <time.h>
#define N 100

// Definition of the Q
typedef struct Q {
   int* q;
   int pos;
} Q;

// Create a Q of integers that are the work items.
struct Q* initQ(int n) {
   int i;
   struct Q *newQ = (struct Q *) malloc(sizeof(Q));   
   newQ->q = (int*) malloc(sizeof(int)*n);
   newQ->pos = n-1;

   for (int i = 0; i < n; i++) {
      if (rand( ) < 200000000) newQ->q[i] = 1;
      else newQ->q[i] = 0;
      printf("q[%d] = %d\n", i, newQ->q[i]);
   }
   return newQ;
}

void doWork(int s) {
   sleep(s);
}

int getWork(struct Q* workQ) {
   if (workQ->pos > -1) {
      int w = workQ->q[workQ->pos];
      workQ->pos--;
      return w;
   } else {
      return -1;
   }
}

int main (int argc, char *argv[]) {
   
   Q* q = initQ(N);
   int w = getWork(q);
   double t = omp_get_wtime( );
   while (w > -1) {
      doWork(w);
      w = getWork(q);
   }
   t = omp_get_wtime( ) - t;
   printf("time for processing is %f\n", t);
}

